質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

88.33%

「Rails 6」環境でgem「nested_form_fields」による動的フォームが動かない

解決済

回答 1

投稿

  • 評価
  • クリップ 0
  • VIEW 863

wkym_4a

score 5

gem「nested_form_fields」の使い方について(そもそもRails 6に対応しているのでしょうか)

 
Rails 6
で動的な入力フォームを実現しようとしているのですが、
Rails 5
で使用していたgem「nested_form_fields」が動かずに詰まっています。

発生している問題・エラーメッセージ

https://www.virment.com/add_and_remove_rails_nested_form_dynamically/
のサイトを参考に、
Rails 5
では問題なく作成できていました。

Rails 6
でもビューの表示まではうまくいっていますが、

【行追加ボタン】

<%= f.add_nested_fields_link :roomtypes, 'Add new', class: 'btn btn-primary', role: 'button' %>

【行削除ボタン】

<td><%= q.remove_nested_fields_link 'Delete', class: 'btn btn-danger', role: 'button' %></td>


を押しても動いてくれない状態です。

試したこと

原因はおそらく、「Rails 5」で
app/assets/javascripts/application.js
に追記していた
//= require nested_form_fields

……「Rails 6」だと「assets」下に「javascripts」フォルダが作成されないので、
requireの方法が違うのだと思うのですが何処にどう書けばいいのかがわかりません。
一応、自分で「app/assets/javascripts/application.js」を作成して「Rails 5」と同様に「//= require」してみましたが動きませんでした。

あるいはgem「nested_form_fields」自体、最終更新日が11ヶ月前なので「Rails 6」に対応していないのかも。
方法の変更も検討しつつのダメ元での質問なのですが、「Rails 6」で「nested_form_fields」をうまく動かせている方っていらっしゃいますか?

補足情報(FW/ツールのバージョンなど)

ruby 2.6.5p114
Rails 6.0.2.1。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

checkベストアンサー

0

requireの方法が違うのだと思うのですが何処にどう書けばいいのかがわかりません。

ERB経由でロードする方法があるとのことです(参考、cocoonについてですが同様の方法で可能かと思います)。

なお、Rails 6ではWebpackerが標準となっているので、Rails 5以下のSprocketsからJavaScript管理の方法が刷新されています。npmで適当なライブラリがあれば、それを入れてしまうほうがいいかもしれません。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2020/02/23 21:43

    参考情報を元にcocoonでも試してみましたが、うまく行かず。

    「現状ではRails 6対応できていないのでは?(出来ていたとしてもやり方を見つけられない!)」ということで、時期早々として環境をRails 5に変更することにしました。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 88.33%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

関連した質問

同じタグがついた質問を見る